#!/usr/bin/python2
# -*- coding: utf-8 -*-
# vi:si:et:sw=4:sts=4:ts=4

import os
from os.path import join, abspath, basename, dirname
import re

name = 'prelinger'
base = abspath(dirname(__file__))
os.chdir(base)

for root, folders, files in os.walk(join(base, 'static')):
    for f in files:
        src = join(root, f)
        target = src.replace(base, '/srv/pandora')
        rel_src = os.path.relpath(src, dirname(target))
        if os.path.exists(target):
            os.unlink(target)
        os.symlink(rel_src, target)
        if f in ('logo.%s.png'%name, 'icon.%s.png'%name):
            t = target.replace('%s.'%name, '')
            if os.path.exists(t):
                os.unlink(t)
            os.symlink(f, os.path.join(dirname(target), t))

'''
overwrite = (
    ('home', 'indiancinema'),
)

os.chdir('/srv/pandora/static/js')
for filename, sitename in overwrite:
    src = '%s.%s.js' % (filename, sitename)
    target = '%s.%s.js' % (filename, name)
    if os.path.exists(target):
        os.unlink(target)
    os.symlink(src, target)
'''

os.chdir(base)
src = join(base, 'config.jsonc')
target = '/srv/pandora/pandora/config.%s.jsonc' % name
rel_src = os.path.relpath(src, dirname(target))
if os.path.exists(target):
    os.unlink(target)
os.symlink(rel_src, target)
t = '/srv/pandora/pandora/config.jsonc'
if os.path.exists(t):
    os.unlink(t)
os.symlink(basename(target), t)

for root, folders, files in os.walk(join(base, 'scripts')):
    for f in files:
        if f.endswith('.pyc'):
            continue
        src = join(root, f)
        target = src.replace(base, '/srv/pandora')
        rel_src = os.path.relpath(src, dirname(target))
        if os.path.exists(target):
            os.unlink(target)
        os.symlink(rel_src, target)
        if f == 'poster.%s.py' % name:
            t = os.path.join(dirname(target), 'poster.py')
            if os.path.exists(t):
                os.unlink(t)
            os.symlink(f, os.path.join(dirname(target), t))

local_settings_py = '/srv/pandora/pandora/local_settings.py'
with open(local_settings_py) as fd:
    local_settings_changed = False
    local_settings = fd.read()
    if not 'LOCAL_APPS' in local_settings:
        local_settings += '\nLOCAL_APPS = ["%s"]\n' % name
        local_settings_changed = True
    else:
        apps = re.compile('(LOCAL_APPS.*?)\]', re.DOTALL).findall(local_settings)[0]
        if not name in apps:
            new_apps = apps.strip() + ',\n"%s"\n' % name
            local_settings = local_settings.replace(apps, new_apps)
            local_settings_changed = True
if local_settings_changed:
    with open(local_settings_py, 'w') as fd:
        fd.write(local_settings)

